<?php

namespace Drupal\drowl_paragraphs_container2layout;

use Drupal\Core\Entity\ContentEntityInterface;

interface ParagraphsConverterInterface {

  /**
   * Helper function to ensure the requirements for the conversion are matched.
   * Throws an exception otherwise.
   *
   * This function should be run before all public actions of this plugin.
   *
   * @throws \Exception
   */
  public function checkRequirements();

  /**
   * Converts the container paragraphs referenced by a paragraph field
   * from the given parent entity.
   *
   * @param Entity $entity
   */
  public function convertFromParentEntity(ContentEntityInterface $entity);

  /**
   * Converts the container paragraphs from all entities, determined by
   * the entity_reference_revisions field type.
   */
  public function convertAllFromAllEntities();

  /**
   * Convert all container paragraphs from the given entit type bundle.
   *
   * @param string $entity_type The entity type.
   * @param string $entity_bundle The entity type bundle name.
   */
  public function convertAllFromBundle(string $entity_type, string $entity_bundle);

}
