<?php

namespace Drupal\Tests\DrowlParagraphsContainer2layout\Functional;

use Drupal\Tests\BrowserTestBase;

/**
 * Default test case for the drowl_paragraphs_container2layout module.
 *
 * @group drowl_paragraphs_container2layout
 * @group drowl_paragraphs
 */
class ContainerParagraphs2LayoutParagraphsActionTest extends BrowserTestBase {

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stark';

  /**
   * {@inheritdoc}
   */
  public static $modules = ['drowl_paragraphs_container2layout'];

  /**
   * The installation profile to use with this test.
   *
   * We need the 'minimal' profile in order to make sure the Tool block is
   * available.
   *
   * @var string
   */
  protected $profile = 'minimal';

  /**
   * Tests if the action is listed on the actions page.
   */
  public function testActionExists() {
    // Create an administrative user.
    $admin_user = $this->drupalCreateUser(['administer actions']);
    $this->drupalLogin($admin_user);

    $this->drupalGet('/admin/config/system/actions');
    $this->assertSession()->pageTextContains('DROWL Paragraphs: Container Paragraphs to Layout Paragraphs action');

  }

}
